package com.njcn.energy.controller;

import com.njcn.common.pojo.annotation.OperateInfo;
import com.njcn.common.pojo.enums.common.LogEnum;
import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.common.utils.HttpResultUtil;
import com.njcn.common.utils.LogUtil;
import com.njcn.energy.pojo.po.EleEpdPqd;
import com.njcn.energy.pojo.po.EleParm;
import com.njcn.energy.service.IEleEpdPqdService;
import com.njcn.energy.service.IEleParmService;
import com.njcn.web.controller.BaseController;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

/**
 * 类的介绍：
 *
 * @author xuyang
 * @version 1.0.0
 * @createTime 2022/3/15 19:44
 */
@Slf4j
@RestController
@RequestMapping("/parm")
@RequiredArgsConstructor
@Api(tags = "设备参数数据管理")
public class EleParmController extends BaseController {

    private final IEleParmService eleParmService;

    @PostMapping("/add")
    @OperateInfo(info = LogEnum.SYSTEM_COMMON)
    @ApiOperation("新增设备参数数据")
    @ApiImplicitParam(name = "eleParm", value = "设备参数数据", required = true)
    public HttpResult<Boolean> add(@RequestBody EleParm eleParm){
        String methodDescribe = getMethodDescribe("add");
        LogUtil.njcnDebug(log, "{}，设备参数数据：{}", methodDescribe, eleParm);
        boolean result = eleParmService.addParm(eleParm);
        return HttpResultUtil.assembleCommonResponseResult(CommonResponseEnum.SUCCESS, result, methodDescribe);
    }

    @PutMapping("/update")
    @OperateInfo(info = LogEnum.SYSTEM_COMMON)
    @ApiOperation("修改设备参数数据")
    @ApiImplicitParam(name = "eleParm", value = "设备参数数据", required = true)
    public HttpResult<Boolean> update(@RequestBody EleParm eleParm){
        String methodDescribe = getMethodDescribe("update");
        LogUtil.njcnDebug(log, "{}，设备参数数据：{}", methodDescribe, eleParm);
        boolean result = eleParmService.updateParm(eleParm);
        return HttpResultUtil.assembleCommonResponseResult(CommonResponseEnum.SUCCESS, result, methodDescribe);
    }

    @GetMapping("/findByName")
    @OperateInfo(info = LogEnum.SYSTEM_COMMON)
    @ApiOperation("根据名称查找数据")
    @ApiImplicitParam(name = "name", value = "名称", required = true)
    public HttpResult<EleParm> findByName(@RequestParam String name){
        String methodDescribe = getMethodDescribe("findByName");
        LogUtil.njcnDebug(log, "{}，名称为：{}", methodDescribe, name);
        EleParm eleParm = eleParmService.findByName(name);
        return HttpResultUtil.assembleCommonResponseResult(CommonResponseEnum.SUCCESS, eleParm, methodDescribe);
    }


}
